object Form1: TForm1
  Left = 183
  Height = 700
  Top = 77
  Width = 996
  Anchors = [akTop, akLeft, akRight, akBottom]
  Caption = 'A Little Computational Geometry  V4.0'
  ClientHeight = 700
  ClientWidth = 996
  Color = clBtnFace
  Font.Color = clWindowText
  Font.Height = -13
  Font.Name = 'MS Sans Serif'
  OnActivate = FormActivate
  Position = poScreenCenter
  LCLVersion = '1.0.6.0'
  object Image1: TImage
    Left = 552
    Height = 409
    Top = 48
    Width = 401
    OnMouseDown = Image1MouseDown
    OnMouseMove = Image1MouseMove
    OnMouseUp = Image1MouseUp
  end
  object Label2: TLabel
    Left = 547
    Height = 1
    Top = 16
    Width = 1
    ParentColor = False
  end
  object ResultLbl: TLabel
    Left = 552
    Height = 89
    Top = 480
    Width = 401
    AutoSize = False
    Caption = 'Results: '
    Font.Color = clWindowText
    Font.Height = -19
    Font.Name = 'MS Sans Serif'
    Font.Style = [fsBold]
    ParentColor = False
    ParentFont = False
    WordWrap = True
  end
  object AreaLbl: TLabel
    Left = 704
    Height = 17
    Top = 16
    Width = 32
    Caption = 'Area:'
    Font.Color = clWindowText
    Font.Height = -13
    Font.Name = 'Aeial'
    ParentColor = False
    ParentFont = False
  end
  object PageControl1: TPageControl
    Left = 32
    Height = 577
    Top = 32
    Width = 505
    ActivePage = LineManip
    Font.Color = clWindowText
    Font.Height = -13
    Font.Name = 'Arial'
    MultiLine = True
    ParentFont = False
    TabIndex = 5
    TabOrder = 0
    OnChange = ClearBtnClick
    Options = [nboMultiLine]
    object IntersectSheet: TTabSheet
      Caption = '1. Intersecting lines'
      ClientHeight = 0
      ClientWidth = 0
      ImageIndex = 1
      object Memo1: TMemo
        Left = 16
        Height = 209
        Top = 8
        Width = 353
        Color = 14548991
        Lines.Strings = (
          'Click define start drawing a line, click '
          'again to end the line.  Repeat to draw a '
          'second line. '
          ''
          'End points alignment may be aligned '
          'on 5 or 10 pixel boundaries by using the '
          '"Point alignment" box.'
          ' '
          'Program will report whether lines '
          'intersect.  (Easy for humans, not so '
          'easy for programs.)'
          ''
        )
        TabOrder = 0
      end
      object AlignGrpIL: TRadioGroup
        Left = 32
        Height = 81
        Top = 240
        Width = 185
        AutoFill = True
        Caption = 'Point alignment'
        ChildSizing.LeftRightSpacing = 6
        ChildSizing.TopBottomSpacing = 6
        ChildSizing.EnlargeHorizontal = crsHomogenousChildResize
        ChildSizing.EnlargeVertical = crsHomogenousChildResize
        ChildSizing.ShrinkHorizontal = crsScaleChilds
        ChildSizing.ShrinkVertical = crsScaleChilds
        ChildSizing.Layout = cclLeftToRightThenTopToBottom
        ChildSizing.ControlsPerLine = 1
        ClientHeight = 59
        ClientWidth = 181
        ItemIndex = 0
        Items.Strings = (
          '1 pixel'
          '5 pixel boundaries'
          '10 pixel boundaries'
        )
        OnClick = AlignGrpClick
        TabOrder = 1
      end
    end
    object PerpSheet: TTabSheet
      Caption = '2. Perpendicular from point to line'
      ClientHeight = 485
      ClientWidth = 497
      ImageIndex = 2
      object Memo2: TMemo
        Left = 24
        Height = 145
        Top = 16
        Width = 305
        Color = 14548991
        Lines.Strings = (
          'Click to start drawing a baseline, click '
          'again to end the line,   then click '
          'at some points not on the line.   '
          ''
          'Program will draw lines from the '
          'clicked points and  perpendicular to '
          'the original base  line. '
          ' '
        )
        TabOrder = 0
      end
    end
    object AngleSheet: TTabSheet
      Caption = '3. Angle from point on line for distance'
      ClientHeight = 0
      ClientWidth = 0
      ImageIndex = 2
      object Label1: TLabel
        Left = 16
        Height = 16
        Top = 272
        Width = 63
        Caption = 'Line length'
        ParentColor = False
      end
      object Label3: TLabel
        Left = 16
        Height = 16
        Top = 304
        Width = 117
        Caption = 'Line angle (degrees)'
        ParentColor = False
      end
      object DistEdt: TSpinEdit
        Left = 152
        Height = 26
        Top = 272
        Width = 57
        MaxValue = 200
        TabOrder = 0
        Value = 25
      end
      object Memo3: TMemo
        Left = 16
        Height = 217
        Top = 0
        Width = 289
        Color = 14548991
        Lines.Strings = (
          'Click to define the start point of a  '
          'baseline, cliick again to end the line.  Then '
          'click any location on or near the line.  '
          ''
          'This procedure generates a line of the '
          'specified length at the  specified angle  to '
          'the reference line and on the specified  '
          'side.  '
          ''
          'The "side" of the line, right or left is as '
          'viewed by a observer walking the reference '
          'line from the initial point. '
        )
        TabOrder = 1
      end
      object RightLeftBox: TRadioGroup
        Left = 16
        Height = 41
        Top = 224
        Width = 249
        AutoFill = True
        Caption = 'Which side of line?'
        ChildSizing.LeftRightSpacing = 6
        ChildSizing.TopBottomSpacing = 6
        ChildSizing.EnlargeHorizontal = crsHomogenousChildResize
        ChildSizing.EnlargeVertical = crsHomogenousChildResize
        ChildSizing.ShrinkHorizontal = crsScaleChilds
        ChildSizing.ShrinkVertical = crsScaleChilds
        ChildSizing.Layout = cclLeftToRightThenTopToBottom
        ChildSizing.ControlsPerLine = 2
        ClientHeight = 19
        ClientWidth = 245
        Columns = 2
        ItemIndex = 0
        Items.Strings = (
          'Right'
          'Left'
        )
        TabOrder = 2
      end
      object AngleEdt: TSpinEdit
        Left = 152
        Height = 26
        Top = 304
        Width = 57
        MaxValue = 180
        TabOrder = 3
        Value = 45
      end
      object AdjustBox: TCheckBox
        Left = 24
        Height = 17
        Top = 336
        Width = 201
        Caption = 'Adjust 1st point to lie on liine'
        Checked = True
        State = cbChecked
        TabOrder = 4
      end
    end
    object PointInPolySheet: TTabSheet
      Caption = '4. Point In Polygon'
      ClientHeight = 0
      ClientWidth = 0
      ImageIndex = 3
      object Memo4: TMemo
        Left = 8
        Height = 257
        Top = 24
        Width = 361
        Color = 14548991
        Lines.Strings = (
          'Click to start a polygon and click at each '
          'corner.  Polygon will be automatically '
          'closed when you click near the starting '
          'point.'
          ''
          'Then click additional points and displayed '
          'message will tell you if you are inside the '
          'polygon, outside the polygon, on a vertex, '
          'or on the border but not on a vertex. '
          ' '
          'Algorithm works by extending a line from '
          'the point to infinity and counting the number '
          'of polygon edges that are intersected.  '
          'Odd count =inside, even count = outside! '
        )
        TabOrder = 0
      end
      object AlignGrp: TRadioGroup
        Left = 16
        Height = 81
        Top = 328
        Width = 185
        AutoFill = True
        Caption = 'Point alignment'
        ChildSizing.LeftRightSpacing = 6
        ChildSizing.TopBottomSpacing = 6
        ChildSizing.EnlargeHorizontal = crsHomogenousChildResize
        ChildSizing.EnlargeVertical = crsHomogenousChildResize
        ChildSizing.ShrinkHorizontal = crsScaleChilds
        ChildSizing.ShrinkVertical = crsScaleChilds
        ChildSizing.Layout = cclLeftToRightThenTopToBottom
        ChildSizing.ControlsPerLine = 1
        ClientHeight = 59
        ClientWidth = 181
        ItemIndex = 0
        Items.Strings = (
          '1 pixel'
          '5 pixel boundaries'
          '10 pixel boundaries'
        )
        OnClick = AlignGrpClick
        TabOrder = 1
      end
    end
    object InflateSheet: TTabSheet
      Caption = '5. Inflate Polygon'
      ClientHeight = 0
      ClientWidth = 0
      ImageIndex = 4
      object Label4: TLabel
        Left = 48
        Height = 20
        Top = 390
        Width = 65
        Caption = 'Inflate by'
        Font.Color = clWindowText
        Font.Height = -16
        Font.Name = 'MS Sans Serif'
        ParentColor = False
        ParentFont = False
      end
      object Label5: TLabel
        Left = 168
        Height = 20
        Top = 390
        Width = 39
        Caption = 'pixels'
        Font.Color = clWindowText
        Font.Height = -16
        Font.Name = 'MS Sans Serif'
        ParentColor = False
        ParentFont = False
      end
      object Memo5: TMemo
        Left = 8
        Height = 361
        Top = 8
        Width = 281
        Color = 14548991
        Lines.Strings = (
          'Click the image area at right  to start a '
          'polygon and click at each corner.   Polygon '
          'will be automatically closed when you click '
          'near the starting point.'
          ''
          'When the polygon is closed, it will be'
          'inflated (or deflated) by the pixel value'
          'given below. Negative values will reduce the'
          'polygon size. The value given is the '
          'perpendular pixel distance from each existing '
          'edge to the new edge.  Clicking the up/down '
          'arrows on the value below will redraw the '
          'polygon inflated by the new value.'
          ''
          'Algorithm works by finding points at the '
          'perpendicular distance from each end of each '
          'edge.   This defines slope and intercept of a '
          'new edge line (but probably not intersecting).  '
          'We then extend each adjacent pair of lines if '
          'necessay to find the intersection point which '
          'defines a new vertex for the inflated polygon.   '
        )
        TabOrder = 0
      end
      object InflateBy: TSpinEdit
        Left = 120
        Height = 26
        Top = 387
        Width = 41
        MaxValue = 50
        MinValue = -50
        OnChange = InflateByChange
        TabOrder = 1
        Value = 10
      end
    end
    object LineManip: TTabSheet
      Caption = '6. Line Translate/Rotate'
      ClientHeight = 485
      ClientWidth = 497
      ImageIndex = 6
      object Label6: TLabel
        Left = 24
        Height = 17
        Top = 208
        Width = 135
        Caption = 'Translate start point to:'
        ParentColor = False
      end
      object Label7: TLabel
        Left = 24
        Height = 25
        Top = 232
        Width = 17
        Caption = 'X'
        Font.Color = clWindowText
        Font.Height = -19
        Font.Name = 'MS Sans Serif'
        Font.Style = [fsBold]
        ParentColor = False
        ParentFont = False
      end
      object Label8: TLabel
        Left = 140
        Height = 25
        Top = 231
        Width = 15
        Caption = 'Y'
        Font.Color = clWindowText
        Font.Height = -19
        Font.Name = 'MS Sans Serif'
        Font.Style = [fsBold]
        ParentColor = False
        ParentFont = False
      end
      object Label9: TLabel
        Left = 24
        Height = 17
        Top = 280
        Width = 156
        Caption = 'Rotate about start point to:'
        ParentColor = False
      end
      object Label10: TLabel
        Left = 112
        Height = 17
        Top = 304
        Width = 47
        Caption = 'degrees'
        ParentColor = False
      end
      object Memo6: TMemo
        Left = 56
        Height = 185
        Top = 8
        Width = 289
        Color = 14548991
        Lines.Strings = (
          'Click to start a line.  Move the mouse and click '
          'again to end the line.  '
          ''
          'Buttons below wil translate or rotate the line,'
          ''
          'These routines to translate and rotates lines are '
          'required for the Circle-Circle intersection  '
          'operations.'
        )
        TabOrder = 0
      end
      object SpinEdit2: TSpinEdit
        Left = 156
        Height = 24
        Top = 232
        Width = 84
        MaxValue = 1000
        TabOrder = 1
      end
      object TranslateBtn: TButton
        Left = 244
        Height = 25
        Top = 231
        Width = 65
        Caption = 'Go'
        OnClick = TranslateBtnClick
        TabOrder = 2
      end
      object RotateBtn: TButton
        Left = 244
        Height = 25
        Top = 303
        Width = 65
        Caption = 'Go'
        OnClick = RotateBtnClick
        TabOrder = 3
      end
      object SpinEdit1: TSpinEdit
        Left = 48
        Height = 24
        Top = 232
        Width = 76
        MaxValue = 1000
        TabOrder = 4
      end
      object SpinEdit3: TSpinEdit
        Left = 56
        Height = 24
        Top = 304
        Width = 49
        MaxValue = 360
        MinValue = -360
        TabOrder = 5
        Value = 45
      end
      object Memo7: TMemo
        Left = 8
        Height = 97
        Top = 352
        Width = 281
        Lines.Strings = (
          ''
        )
        TabOrder = 6
      end
    end
    object CircleCircleIntersectSheet: TTabSheet
      Caption = '7. Circle-Circle Intersection '
      ClientHeight = 0
      ClientWidth = 0
      ImageIndex = 7
      object Memo9: TMemo
        Left = 16
        Height = 185
        Top = 16
        Width = 433
        Color = 14548991
        Lines.Strings = (
          'Click the button below to generate 2 random circles and draw lines from '
          'center of the fiirst circle to the interesction points with the second (if they '
          'intersect).   Circle-Circle intersection operations are  required when  '
          'calculating tangent lines for circles.'
          ''
          'The algorithm requires translating and rotating the line connecting the '
          'cirlce centers to (0,0) origin and 0 degree angle.  Realtively simple '
          'equations then allow the intersection point coordinates to be calculated,  '
          'after which the lines from the origin to the intersection points can be '
          'rotated and translated back to the original origin and orientation.  '
        )
        TabOrder = 0
      end
      object CCIntersectBtn: TButton
        Left = 16
        Height = 25
        Top = 224
        Width = 225
        Caption = 'Generate && test 2 random circles '
        OnClick = CCIntersectBtnClick
        TabOrder = 1
      end
      object Memo10: TMemo
        Left = 8
        Height = 201
        Top = 272
        Width = 449
        Lines.Strings = (
          ''
        )
        ScrollBars = ssVertical
        TabOrder = 2
      end
    end
    object TangentPC: TTabSheet
      Caption = '8. Point-Circle Tangent'
      ClientHeight = 0
      ClientWidth = 0
      ImageIndex = 5
      object Memo8: TMemo
        Left = 24
        Height = 321
        Top = 16
        Width = 401
        Color = 14548991
        Lines.Strings = (
          'Click the button below to draw a random circle and a random '
          'external point;'
          ''
          'The algorithm is'
          ''
          '1. Define the line,L, from the point, P, to the circle center.'
          '2.  Find the midpoint, M, of line L}'
          '3.  Define the circle, C1, centered on M through the endpoints of L.'
          '4,  Define the circle, C2, to be the original circle with center a C.'
          '5.  Find the intersection points of C1 and C2, call them IP1 and '
          'IP2'
          '6   Define the tangent lines  from P through IP1 and IP2'
          ''
          'Notice that angles (C,I P1,P) and (C,IP2,P)  are inscribed angles of '
          'C2 and are therefore right angles. This  makes points IP1 and IP2 '
          'points of tangency by definition.'
          ''
        )
        TabOrder = 0
      end
      object PointTanBtn: TButton
        Left = 32
        Height = 25
        Top = 392
        Width = 369
        Caption = 'Generate tangent lines for random circle and external point'
        OnClick = PointTanBtnClick
        TabOrder = 1
      end
    end
    object TabSheet1: TTabSheet
      Caption = '9. Circle - Circle Tangent Lines'
      ClientHeight = 0
      ClientWidth = 0
      ImageIndex = 8
      object Memo11: TMemo
        Left = 24
        Height = 305
        Top = 16
        Width = 401
        Color = 14548991
        Lines.Strings = (
          'Click the button below to draw 2 random circles for which the the 2 '
          'exterior lines tangent to both circles will be calculated.'
          ''
          'The algorithm is'
          ''
          '1. Name the given circles C1 and C2 with radii R1 and R2 such that '
          'R1>=R2.'
          '2. Define a circle , C3, centered on C1 with a radius equal R1-R2. '
          '(Yellow on the diagram)'
          '3..Use the Point-Circle algorithm presented on another sheet to find'
          'the lines, L1 and L2, through the center of C2 and and tangent to '
          'C3. (Also drawn in yellow.)'
          '3. Define the lines, PL1 and PL2, through the center of C2 and '
          'perpendicular to L1 and L2.  (Green lines.)'
          '4. Translate L1 a distance R2 along PL1 and L2 and distance R2 '
          'along PL2 to create the two exteroir tangent lines.  (Blue lines.)'
          ''
          ''
        )
        TabOrder = 0
      end
      object CircCircTanBtn: TButton
        Left = 32
        Height = 25
        Top = 344
        Width = 385
        Caption = 'Create 2 random circles and  their exterior tangent lines. '
        OnClick = CircCircTanBtnClick
        TabOrder = 1
      end
    end
  end
  object ClearBtn: TButton
    Left = 544
    Height = 25
    Top = 584
    Width = 75
    Caption = 'Clear'
    OnClick = ClearBtnClick
    TabOrder = 1
  end
  object StaticText1: TStaticText
    Cursor = crHandPoint
    Left = 0
    Height = 20
    Top = 680
    Width = 996
    Align = alBottom
    Alignment = taCenter
    Caption = 'Copyright  © 2002 - 2008, Gary Darby,  www.DelphiForFun.org'
    Font.Color = clBlue
    Font.Height = -13
    Font.Name = 'MS Sans Serif'
    Font.Style = [fsBold, fsUnderline]
    OnClick = StaticText1Click
    ParentFont = False
    TabOrder = 2
  end
end
